# Generated by Django 2.2.24 on 2021-06-08 05:08

import datetime
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('organization', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='ProjectNumber',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('year', models.IntegerField(unique=True)),
                ('last_date', models.DateField()),
                ('last_onumber', models.IntegerField(blank=True, null=True)),
                ('last_cnumber', models.IntegerField(blank=True, null=True)),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='project_projectnumber_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='project_projectnumber_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
            ],
            options={
                'verbose_name': 'project number',
                'verbose_name_plural': 'project numbers',
                'ordering': ('ordering',),
                'permissions': (('list_projectnumber', 'Can list project number'), ('detail_projectnumber', 'Can detail project number'), ('disable_projectnumber', 'Can disable project number')),
            },
        ),
        migrations.CreateModel(
            name='Project',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('name', models.CharField(max_length=255, verbose_name='name')),
                ('description', models.TextField(blank=True, verbose_name='description')),
                ('date_start', models.DateField(db_index=True, default=datetime.date.today, verbose_name='start date')),
                ('date_end', models.DateField(blank=True, db_index=True, null=True, verbose_name='end date')),
                ('pnumber', models.CharField(blank=True, max_length=50)),
                ('cnumber', models.CharField(blank=True, max_length=50)),
                ('accepted', models.BooleanField(db_index=True, default=False, verbose_name='Accepted')),
                ('o_date', models.DateField(blank=True, null=True)),
                ('c_date', models.DateField(blank=True, null=True)),
                ('date_start_site', models.DateField(blank=True, null=True)),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='project_project_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='project_project_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
                ('organization', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='projects', to='organization.Organization', verbose_name='organization')),
            ],
            options={
                'verbose_name': 'project',
                'verbose_name_plural': 'projects',
                'ordering': ('ordering', 'name'),
                'permissions': (('list_project', 'Can list project'), ('detail_project', 'Can detail project'), ('disable_project', 'Can disable project')),
            },
        ),
    ]
